Subject: bug#40838: 28.0.50; [feature/native-comp] Function overrides in init.el are not honored after deferred compilation

From: Ihor Radchenko <[email-masked]>
Date: Mon, 18 May 2020 23:23:49 +0800

> thanks this is appreciated because I haven't managed to reproduce it
> myself.

Finally, I found some reproducible example.
straight.el redefines some org functions before loading org.
It is done in straight--fix-org-function (org-git-version and
org-release are redefined). 
The redefined version works with org.elc, but somehow get overridden
when org.eln is loaded (in my case, the loading is triggered by elfeed-org).

Steps to reproduce:

1. Use the attached file to load emacs. No errors should appear.
2. Wait until org is native-compiled.
3. Restart emacs. The following errors appears
(straight--fix-org-function supposed to be a workaround for this error):

Error (use-package): elfeed-org/:catch: Invalid version syntax: ‘N/A’
(must start with a number)

4. Delete org.eln
5. Restart emacs. The error disappears.

Best,
Ihor

Andrea Corallo <[email-masked]> writes:

> Ihor Radchenko <[email-masked]> writes:
>
>>> It would certanly help if you could provide a reproducer.
>>
>> I was trying to make a simple recipe to reproduce this, but failed.
>> The bug only appears with my config (though I do not see any problem
>> when not using native-comp branch).
>> Will try to narrow down the exact cause, but it may take a while.
>>
>> Best,
>> Ihor
>
> Hi Ihor,
>
> thanks this is appreciated because I haven't managed to reproduce it
> myself.
>
> Thanks
>
>   Andrea
>
> -- 
> [email-masked]

-- 
Ihor Radchenko,
PhD,
Center for Advancing Materials Performance from the Nanoscale (CAMP-nano)
State Key Laboratory for Mechanical Behavior of Materials, Xi'an Jiaotong University, Xi'an, China
Email: [email-masked], [email-masked]